﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace MoHooSpore.Test
{
    class Program
    {
        static void Main(string[] args)
        {
            string demo = Path.Combine(AppDomain.CurrentDomain.BaseDirectory, "demo.txt");
            string demo2 = Path.Combine(AppDomain.CurrentDomain.BaseDirectory, "demo2.txt");
            string book = Path.Combine(AppDomain.CurrentDomain.BaseDirectory, "demo.png");

            // 写入
            using (var fs = new FileStream(book, FileMode.Open))
            {
                FileWriter writer = new FileWriter(fs);
                writer.Write(new string[] { demo, demo2 });
            }
            Console.WriteLine("附加数据已写入，可以使用16进制查看工具打开demo.png检查数据。");
            Console.WriteLine("按任意键测试读取...");
            Console.ReadLine();
            Console.WriteLine("开始读取附加数据...");
            // 读取
            using (var fs = new FileStream(book, FileMode.Open))
            {
                FileReader reader = new FileReader(fs);
                var files = reader.Read();

                if (files != null)
                {
                    foreach (var f in files)
                    {
                        Console.WriteLine("================================");
                        Console.WriteLine(f.FileName);
                        Console.WriteLine("--------------------------------");

                        // 由于引用的是同一个数据流，所以每次读取内部包含的数据的时候都必须重置一下，以使流的起始位置正确定位
                        f.Stream.Reset();
                        // 然后就可以对流进行任意操作
                        using (var rdr = new StreamReader(f.Stream))
                        {
                            Console.WriteLine(rdr.ReadToEnd());
                        }
                    }
                }
            }
            Console.WriteLine("读取完毕，按任意键退出...");

            Console.ReadLine();
        }
    }
}
