﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using System.Diagnostics;

namespace MoHooSpore
{
    public class EmbedFileStream : Stream
    {
        private long position;
        private long length;
        private long offset;
        private Stream stream;

        public EmbedFileStream(Stream stream, long offset, long length)
        {
            this.stream = stream;
            this.offset = offset;
            this.length = length;
        }

        public void Reset()
        {
            this.stream.Seek(this.offset + this.position, SeekOrigin.Begin);
        }

        public void SaveTo(string path)
        {
            // TODO:写入独立存储
        }

        public override bool CanRead
        {
            get { return true; }
        }

        public override bool CanSeek
        {
            get { return false; }
        }

        public override bool CanWrite
        {
            get { return false; }
        }

        public override void Flush()
        {
            throw new NotImplementedException();
        }

        public override long Length
        {
            get { return this.length; }
        }

        public override long Position
        {
            get
            {
                return this.position;
            }
            set
            {
                throw new NotImplementedException();
            }
        }

        public override int Read(byte[] buffer, int offset, int count)
        {
            if (this.position + count > this.length)
            {
                count = (int)(this.length - this.position);
            }
            var readed = this.stream.Read(buffer, offset, count);
            position += readed;

            return readed;
        }

        public override long Seek(long offset, SeekOrigin origin)
        {
            throw new NotImplementedException();
        }

        public override void SetLength(long value)
        {
            throw new NotImplementedException();
        }

        public override void Write(byte[] buffer, int offset, int count)
        {
            throw new NotImplementedException();
        }
    }
}
